#ifndef __STR_FIND_H
#include <str_find.h>
#endif

/**********************************************************************
 *  FONTLEX()
 *  fontlex    
 *    DOS    HTML.
 *
 * :      
 *  POST_LEX  SPEC_C!
 *
 *  : UCHAR *stringz -- ,    ,
 *                    int *n --  .
 *
 *  : E_OK   .
 *    :
 *                              E_BAD_STR
 *                              E_BAD_SUBSTR
 *                              E_BAD_NUM
 *                              E_BAD_MEMORY_HEAP
 *
*
 *
 *********************************************************************/
int fontlex( UCHAR *stringz, int *n )
{
/*  */
  UCHAR cthefont, coldfont; /*  ,  .*/
  int i, iLine, iCol, iCond, il2, ierr;
  UCHAR cd[2]={0xff,0x00}; /* Debug! */
  cthefont = '0';
  iCol = 0;
  ierr = E_OK;
/*       */
  while( iCol < *n )
  {
/*   <Alt+255>.     --  */
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto ERROR;
/*    */
  coldfont = cthefont;
  cthefont=stringz[++iCol];
    switch( cthefont )
    {
/*    , ... */
      case '1':
        switch( coldfont )
        {
/*    ,  <ALT+255>1   </I>  .. */
        case '1':
          ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
          break;
/*   --  */
        case '2':
          ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
          break;
/*   --   */
        case '3':
          ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
          break;
/*   --  */
        case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*      HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<I>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

/*    --  */
      case '2':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*      HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<B>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

/*   --   */
      case '3':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*       HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<B><I>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

      case '4':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*      HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<SUB>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

      case '5':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*     HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<SUP>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

/*   -- . */
      case '7':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
/*      HTML */
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<FONT FACE=\"Symbol\">", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

      case '6':
      case '8':
      case '9':
      case '0':
	switch( coldfont )
	{
/*    ,  <ALT+255>1   </I>  .. */
	case '1':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I>", *n );
	  break;
/*   --  */
	case '2':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</B>", *n );
	  break;
/*   --   */
	case '3':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</I></B>", *n );
	  break;
/*   --  */
	case '4':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUB>", *n );
	  break;
/*   --  */
	case '5':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</SUP>", *n );
	  break;
/*   --  */
	case '7':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</FONT>", *n );
      break;
	case '6':
	case '8':
	case '9':
	case '0':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
    case '_':
    case '.':
			break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
      }
      break;

      default:
	cthefont = '0';
    }
  }

  cthefont = '.';
  iCol = 0;
  ierr = E_OK;
/*       */
  while( iCol < *n )
  {
/*   <Alt+255>.     --  */
    iCol=istrFind_FWD( stringz, &cd[0], iCol, *n, &il2 );
    if( iCol == E_NO_OCCURENCE ) break;
    if( iCol < 0 ) goto ERROR;
/*       */
/*    */
  coldfont = cthefont;
  cthefont=stringz[++iCol];
    switch( cthefont )
    {
/*   --   */
     case '_':
	switch( coldfont )
	{
/*   --   */
	case '_':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</U>", *n );
	  break;
/*   --   */
	case '.':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
/*        */
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case '0':
	  break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	     break;
       }
      if( ierr != E_OK ) goto ERROR;
      ierr=istrInsert( stringz, (UCHAR *)"<U>", iCol, *n );
      if( ierr != E_OK ) goto ERROR;
      break;

/*   --   */
      case '.':
	switch( coldfont )
	{
/*   --   */
	case '_':
      ierr=istrReplace( stringz, --iCol, 2, (UCHAR *)"</U>", *n );
	  break;
/*   --   */
	case '.':
	ierr=istrDelete( stringz, --iCol, 2, *n );
	  break;
/*        */
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case '0':
	  break;
	default:
	ierr=istrDelete( stringz, --iCol, 2, *n );
	     break;
       }
	break;
      default:
	cthefont = '.';
    }
  }
/*   */
/* ,   */
    ERROR:
  return ierr;
}
/*   */
