#ifndef __STDIO_H
#include <stdio.h>
#endif

#ifndef __STRING_H
#include <string.h>
#endif

#ifndef __MEM_H
#include <mem.h>
#endif

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/* #ifndef __ALLOC_H
#include <alloc.h>
#endif */

#ifndef __STR_FIND_H
#include <str_find.h>
#endif

#ifndef __INICREA_H
#include <inicrea.h>
#endif

/**********************************************************************
 *
 * int single_str( int, FILE *, FILE *)
 *
 * 㭪 singlestr ८ࠧ    ப. 
 * ࠧ 묨 ப.
 *
 * ࠬ 㭪樨:   int n --  ப
 *                      FILE *fstream -- 室 ⮪
 *                      FILE *writestream -- 室 ⮪.
 *
 * 頥 祭:
 *
**********************************************************************/


int single_str( int n, FILE *fstream, FILE *writestream )
{
  int iCol, ierr;
  UCHAR cc;
  /*-----------------25/11/03 22:14-------------------
   樠
  --------------------------------------------------*/
  UCHAR *stringz = NULL, *strNew = NULL;
  iCol = 0; ierr=E_OK;
  if( (stringz = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  if( (strNew = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
  {
    free( stringz );
    return E_BAD_MEMORY_HEAP;
  }
  /*-----------------25/11/03 22:17-------------------
      ⨣  ⮪ .
  --------------------------------------------------*/
  while ( !feof( fstream ) )
  {
    /*-----------------25/11/03 22:36-------------------
     ⠥  ப:
    --------------------------------------------------*/
    if( fgets( (char *)stringz, n, fstream ) == NULL ) goto M1;
    M2: iCol = 0;
    if ( ( cc=stringz[iCol] ) ==' ' || cc == '\t' )
    {
      /*-----------------25/11/03 22:38-------------------
       ᫨  ᨬ -- ஡  ⠡樨,  㤠塞 
      --------------------------------------------------*/
      while ( (cc=stringz[iCol]) == ' ' || cc == '\t' )
      {
	ierr=istrDelete( stringz, iCol, 1, n );
	if( ierr != E_OK )
	{
	  free( stringz); free(strNew); return ierr;
	}
      }
    }
    /*-----------------25/11/03 22:39-------------------
     ⠢塞  砫 ப ᨬ ॢ ப
    --------------------------------------------------*/
    ierr=istrInsert( stringz, (UCHAR *)"\n", 0, n );
	if( ierr != E_OK )
	{
	  free( stringz); free(strNew); return ierr;
	}
    /*-----------------28/11/03 21:37-------------------
     㫥 ன ப:
    --------------------------------------------------*/
	M3: memset( (char *)strNew, '\0', (size_t)n );
    /*-----------------25/11/03 22:42-------------------
     ⠥  ப
    --------------------------------------------------*/
    if( fgets( (char *)strNew, n, fstream ) == NULL ) goto M1;
    iCol = 0;
    /*-----------------25/11/03 22:43-------------------
     ᫨  ப , 뢠  ப
      室 ⮪
    --------------------------------------------------*/
      if( !strncmp( (const char *)strNew,"", (size_t)n) )
      {
	if( fputs( (const char *)stringz, writestream ) == EOF )
	{
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
	}
	if( fputs( "\n", writestream ) == EOF )
        {
          free( stringz); free(strNew); return EFILE_DONT_WRITE;
        }
        /*-----------------28/11/03 21:11-------------------
         室  த 横
        --------------------------------------------------*/
        continue;
      }
      /*-----------------28/11/03 21:13-------------------
       ᫨  ப 稭  , 
      --------------------------------------------------*/
      if ( ( cc=strNew[0] ) ==' ' || cc == '\t' )
      {
	int numNew;
        /*-----------------28/11/03 21:17-------------------
         1. 뢠  ப  ⮪ 뢮:
        --------------------------------------------------*/
        if( fputs( (const char *)stringz, writestream ) == EOF )
        {
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
        }
        /*-----------------28/11/03 21:19-------------------
         2. 㥬  ப  
        --------------------------------------------------*/
	numNew=strlen( (const char*)strNew );
	numNew = (numNew < n ) ? numNew : n;
	memset( (char *)stringz, '\0', n );
	strncpy( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:27-------------------
	 3. 室  ࠡ ࢮ ப
	--------------------------------------------------*/
	goto M2;
      }
      /*-----------------28/11/03 21:32-------------------
       :
      --------------------------------------------------*/
      else
      {
	int num, numNew;
	/*-----------------28/11/03 21:34-------------------
	 1.  ⥭ ࢮ ப  ன
	--------------------------------------------------*/
	num = strlen( (const char *)stringz ); numNew=strlen( (const char *)strNew );
	stringz[--num]='\0';
	numNew = (numNew + num < n ) ? numNew : n - num;
	strncat( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:40-------------------
	 2. 室  ⥭ ன ப:
	--------------------------------------------------*/
	goto M3;
      }
  }
  /*  横 */
/* 室, ᫨ 訡 */
    M1:
  if( feof( fstream ) )
	{
	  free( stringz); free(strNew); ierr=E_OK;
	}
  else
  {
    free( stringz ); free( strNew); ierr=EFILE_DONT_READ;
  }
  return ierr;
}
/*  ணࠬ */


/*-----------------28/11/03 22:37-------------------
  noneol( int, FILE *, FILE *)
 *
 * 㭪 noneol 㡨ࠥ 譨  ப  㬥
 *
 * ࠬ 㭪樨:   int n --  ப
 *                      FILE *fstream -- 室 ⮪
 *                      FILE *writestream -- 室 ⮪.
 *
 * 頥 祭:
 *
--------------------------------------------------*/
int noneol( int n, FILE *fstream, FILE *writestream )
{
  /* 樠 */
  int ierr;
  UCHAR cc;
  UCHAR *stringz = NULL;
  ierr=E_OK;
  if( (stringz = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  /*-----------------25/11/03 22:17-------------------
      ⨣  ⮪ .
  --------------------------------------------------*/
  while ( !feof( fstream ) )
  {
    /*-----------------28/11/03 22:50-------------------
     塞 ப
    --------------------------------------------------*/
    memset( (char *)stringz, '\0', n);
    /*-----------------25/11/03 22:36-------------------
     ⠥  ப:
    --------------------------------------------------*/
    if( fgets( (char *)stringz, n, fstream ) == NULL ) goto M1;
    /*-----------------28/11/03 22:55-------------------
     ᫨ ⥪ ப -- ,   室  砫 横
    --------------------------------------------------*/
    if( (cc=stringz[0]) == '\0' || cc == '\r' || cc == '\n')
      continue;
    else
    /*-----------------28/11/03 22:57-------------------
      뢮 ப  䠩
    --------------------------------------------------*/
	if( fputs( (const char *)stringz, writestream ) == EOF )
	{
	  free( stringz); return EFILE_DONT_WRITE;
	}
  }
  M1:
  if( feof( fstream ) )
	{
	  free( stringz);  ierr=E_OK;
	}
  else
  {
    free( stringz ); ierr=EFILE_DONT_READ;
  }
  return ierr;
}

/**********************************************************************
 *
 * int isingle_str( int, FILE *, FILE *)
 *
 * 㭪 isinglestr ८ࠧ    ப. 
 * 祬  ࠧ  稭   ப.
 *
 * ࠬ 㭪樨:   int n --  ப
 *                      FILE *fstream -- 室 ⮪
 *                      FILE *writestream -- 室 ⮪.
 *
 * 頥 祭:
 *
**********************************************************************/

int isingle_str( int n, FILE *fstream, FILE *writestream )
{
  int iCol, ierr;
  UCHAR cc;
  /*-----------------25/11/03 22:14-------------------
   樠
  --------------------------------------------------*/
  UCHAR *stringz = NULL, *strNew = NULL;
  iCol = 0; ierr=E_OK;
  if( (stringz = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  if( (strNew = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
  {
    free( stringz );
    return E_BAD_MEMORY_HEAP;
  }
  /*-----------------25/11/03 22:17-------------------
      ⨣  ⮪ .
  --------------------------------------------------*/
  while ( !feof( fstream ) )
  {
    /*-----------------25/11/03 22:36-------------------
     ⠥  ப:
    --------------------------------------------------*/
    if( fgets( (char *)stringz, n, fstream ) == NULL ) goto M1;
    M2: iCol = 0;
    if ( ( cc=stringz[iCol] ) ==' ' || cc == '\t' )
    {
      /*-----------------25/11/03 22:38-------------------
       ᫨  ᨬ -- ஡  ⠡樨,  㤠塞 
      --------------------------------------------------*/
      while ( (cc=stringz[iCol]) == ' ' || cc == '\t' )
      {
	ierr=istrDelete( stringz, iCol, 1, n );
	if( ierr != E_OK )
	{
	  free( stringz); free(strNew); return ierr;
	}
      }
    }
    /*-----------------28/11/03 21:37-------------------
     㫥 ன ப:
    --------------------------------------------------*/
	M3: memset( (char *)strNew, '\0', n );
    /*-----------------25/11/03 22:42-------------------
     ⠥  ப
    --------------------------------------------------*/
    if( fgets( (char *)strNew, n, fstream ) == NULL ) goto M1;
    iCol = 0;
    /*-----------------25/11/03 22:43-------------------
     ᫨  ப , 뢠  ப
      室 ⮪
    --------------------------------------------------*/
      if( !strncmp( (char *)strNew,"\n",n) )
      {
	int numNew;
	/*-----------------28/11/03 21:17-------------------
	 1. 뢠  ப  ⮪ 뢮:
	--------------------------------------------------*/
	if( fputs( (const char *)stringz, writestream ) == EOF )
	{
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
	}
	/*-----------------28/11/03 21:19-------------------
	 2. 㥬  ப  
	--------------------------------------------------*/
	numNew=strlen( (const char *)strNew );
	numNew = (numNew < n ) ? numNew : n;
	memset( (char *)stringz, '\0', n );
	strncpy( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:11-------------------
	 室  த 横
	--------------------------------------------------*/
	continue;
      }
      /*-----------------28/11/03 21:13-------------------
       ᫨  ப 稭  , 
      --------------------------------------------------*/
      if ( ( cc=strNew[0] ) ==' ' || cc == '\t' )
      {
	int numNew;
	/*-----------------28/11/03 21:17-------------------
	 1. 뢠  ப  ⮪ 뢮:
	--------------------------------------------------*/
	if( fputs( (char *)stringz, writestream ) == EOF )
	{
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
	}
	/*-----------------28/11/03 21:19-------------------
	 2. 㥬  ப  
	--------------------------------------------------*/
	numNew=strlen( (const char *)strNew );
	numNew = (numNew < n ) ? numNew : n;
	memset( (char *)stringz, '\0', n );
	strncpy( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:27-------------------
	 3. 室  ࠡ ࢮ ப
	--------------------------------------------------*/
	goto M2;
      }
      /*-----------------28/11/03 21:32-------------------
       :
      --------------------------------------------------*/
      else
      {
	int num, numNew;
	/*-----------------28/11/03 21:34-------------------
	 1.  ⥭ ࢮ ப  ன
	--------------------------------------------------*/
	num = strlen( (const char *)stringz ); numNew=strlen( (const char *)strNew );
	stringz[--num]='\0';
	numNew = (numNew + num < n ) ? numNew : n - num;
	strncat( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:40-------------------
	 2. 室  ⥭ ன ப:
	--------------------------------------------------*/
	goto M3;
      }
  }
  /*  横 */
/* 室, ᫨ 訡 */
    M1:
  if( feof( fstream ) )
	{
	  free( stringz); free(strNew); ierr=E_OK;
	}
  else
  {
    free( stringz ); free( strNew); ierr=EFILE_DONT_READ;
  }
  return ierr;
}
/*  ணࠬ */

/**********************************************************************
 *
 * int iHT_Main( int, FILE *, FILE *)
 *
 * 㭪 iHT_Main ८ࠧ    ப. 
 * 祬  ࠧ  稭   ப.
 *
 *  ⠥ ப ਬ 䨫 post_lex_strn  fontlex.
 *
 * ࠬ 㭪樨:   int n --  ப
 *                      FILE *fstream -- 室 ⮪
 *                      FILE *writestream -- 室 ⮪.
 *
 * 頥 祭:
 *
**********************************************************************/

int iHT_Main( int n, FILE *fstream, FILE *writestream )
{
  int iCol, ierr;
  UCHAR cc;
  /*-----------------25/11/03 22:14-------------------
   樠
  --------------------------------------------------*/
  UCHAR *stringz = NULL, *strNew = NULL;
  iCol = 0; ierr=E_OK;
  if( (stringz = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  if( (strNew = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
  {
    free( stringz );
    return E_BAD_MEMORY_HEAP;
  }
  /*-----------------25/11/03 22:17-------------------
      ⨣  ⮪ .
  --------------------------------------------------*/
  while ( !feof( fstream ) )
  {
    /*-----------------25/11/03 22:36-------------------
     ⠥  ப:
    --------------------------------------------------*/
    if( fgets( (char *)stringz, n, fstream ) == NULL ) goto M1;
    /*-----------------01/12/03 19:17-------------------
     ਬ塞  ⠭ ப 䨫 post_lex_strn:
    --------------------------------------------------*/
    if( (ierr = post_lex_strn( stringz, &n )) != E_OK && ierr!=E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    /*-----------------01/12/03 19:39-------------------
     ਬ塞  ⠭ ப 䨫 spec_c:
    --------------------------------------------------*/
    if( (ierr = spec_c( stringz, &n )) != E_OK && ierr != E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    /*-----------------01/12/03 19:18-------------------
     ਬ塞  ⠭ ப 䨫 fontlex:
    --------------------------------------------------*/
    if( (ierr = fontlex( stringz, &n ) ) != E_OK && ierr!=E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    M2: iCol = 0;
    if ( ( cc=stringz[iCol] ) ==' ' || cc == '\t' )
    {
      /*-----------------25/11/03 22:38-------------------
       ᫨  ᨬ -- ஡  ⠡樨,  㤠塞 
      --------------------------------------------------*/
      while ( (cc=stringz[iCol]) == ' ' || cc == '\t' )
      {
	ierr=istrDelete( stringz, iCol, 1, n );
	if( ierr != E_OK )
	{
	  free( stringz); free(strNew); return ierr;
	}
      }
    }
    /*-----------------28/11/03 21:37-------------------
     㫥 ன ப:
    --------------------------------------------------*/
	M3: memset( (char *)strNew, '\0', n );
    /*-----------------25/11/03 22:42-------------------
     ⠥  ப
    --------------------------------------------------*/
    if( fgets( (char *)strNew, n, fstream ) == NULL ) goto M1;
    /*-----------------01/12/03 19:17-------------------
     ਬ塞  ⠭ ப 䨫 post_lex_strn:
    --------------------------------------------------*/
    if( (ierr = post_lex_strn( strNew, &n )) != E_OK && ierr!=E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    /*-----------------01/12/03 19:39-------------------
     ਬ塞  ⠭ ப 䨫 spec_c:
    --------------------------------------------------*/
    if( (ierr = spec_c( strNew, &n )) != E_OK && ierr != E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    /*-----------------01/12/03 19:18-------------------
     ਬ塞  ⠭ ப 䨫 fontlex:
    --------------------------------------------------*/
    if( (ierr = fontlex( strNew, &n ) ) != E_OK && ierr!=E_NO_OCCURENCE )
    {
      free( stringz );
      free( strNew );
      return ierr;
    }
    iCol = 0;
    /*-----------------25/11/03 22:43-------------------
     ᫨  ப , 뢠  ப
      室 ⮪
    --------------------------------------------------*/
      if( !strncmp( (const char *)strNew,"\n",n) )
      {
	int numNew;
	/*-----------------28/11/03 21:17-------------------
	 1. 뢠  ப  ⮪ 뢮:
	--------------------------------------------------*/
	if( fputs( (const char *)stringz, writestream ) == EOF )
	{
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
	}
	/*-----------------28/11/03 21:19-------------------
	 2. 㥬  ப  
	--------------------------------------------------*/
	numNew=strlen( (const char *)strNew );
	numNew = (numNew < n ) ? numNew : n;
	memset( (char *)stringz, '\0', (size_t)n );
	strncpy( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:11-------------------
	 室  த 横
	--------------------------------------------------*/
	continue;
      }
      /*-----------------28/11/03 21:13-------------------
       ᫨  ப 稭  , 
      --------------------------------------------------*/
      if ( ( cc=strNew[0] ) ==' ' || cc == '\t' )
      {
	int numNew;
	/*-----------------28/11/03 21:17-------------------
	 1. 뢠  ப  ⮪ 뢮:
	--------------------------------------------------*/
	if( fputs( (const char *)stringz, writestream ) == EOF )
	{
	  free( stringz); free(strNew); return EFILE_DONT_WRITE;
	}
	/*-----------------28/11/03 21:19-------------------
	 2. 㥬  ப  
	--------------------------------------------------*/
	numNew=strlen( (const char *)strNew );
	numNew = (numNew < n ) ? numNew : n;
	memset( (char *)stringz, '\0', (size_t)n );
	strncpy( (char *)stringz, (const char *)strNew, numNew );
	/*-----------------28/11/03 21:27-------------------
	 3. 室  ࠡ ࢮ ப
	--------------------------------------------------*/
	goto M2;
      }
      /*-----------------28/11/03 21:32-------------------
       :
      --------------------------------------------------*/
      else
      {
	int num, numNew;
	/*-----------------28/11/03 21:34-------------------
	 1.  ⥭ ࢮ ப  ன
	--------------------------------------------------*/
	num = strlen( (const char *)stringz ); numNew=strlen( (const char *)strNew );
	stringz[--num]='\0';
	numNew = (numNew + num < n ) ? numNew : n - num;
	strncat( (char *)stringz, (const char *)strNew, (size_t)numNew );
	/*-----------------28/11/03 21:40-------------------
	 2. 室  ⥭ ன ப:
	--------------------------------------------------*/
	goto M3;
      }
  }
  /*  横 */
/* 室, ᫨ 訡 */
    M1:
  if( feof( fstream ) )
	{
	  free( stringz); free(strNew); ierr=E_OK;
	}
  else
  {
    free( stringz ); free( strNew); ierr=EFILE_DONT_READ;
  }
  return ierr;
}
/*  ணࠬ */
