#ifndef __STR_FIND_H
#include <str_find.h>
#endif
/*********************************************************************
 *
 * STR_FIND.C --   ணࠬ ⥬ ஢ન, ᪠  
 * ⥪⮢ .
 *
 * !  㪭樨 ॠ  樮 ⥬ MS-DOS.
 *  ⮣, ⮡ ᯮ짮   Windows,  㭪樨
 *   ९ᠭ.
 *
*********************************************************************/

#ifndef __STRING_H
#include <string.h>
#endif

/* #ifndef __ALLOC_H
#include <alloc.h>
#endif */

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/******************26/10/06 13:15************************************
 *
 *  isvalid_str
 *
 * 	 㭪 ।祭  ।  ப
 *	 ࠢ   ᨬ쭮  ப.
 *
 * :
 *	*str 	-- ஢塞 ப
 *	n 	-- ᨬ쭠  ப
 *	*il1 	--  ஢塞 ப
 *
 * :
 *
 *	᫨ ⥪  ப  ᨬ쭮
 *	祭 (*il1 > n), 頥 祭:
 *	E_BAD_STR.  頥 E_OK.
 *
 *  :
 *
 *	⠭ 㭪樨   STRING.H
 *
********************************************************************/
int isvalid_str( UCHAR *str, int n, int *il1 )
{
  *il1 = strlen( (const char *)str );
  if ( *il1 > n ) return E_BAD_STR;
  return E_OK;
}

/******************26/10/06 13:18************************************
 *
 *  isvalid_strs
 *
 *	 㭪 ।祭  ।   ப,
 *	ࠢ    ᨬ쭮  ப 
 *	᫥ 㬬୮   ப.
 *
 * :
 *	*str 		-- ஢塞 ப
 *	*substr 	-- ஢塞 ப
 *	num 		-- 砫쭠   ப
 *			   ( ன 뢠 砫 ப)
 *	n 		-- ᨬ쭠  ப
 *	*il1 		--  ⥪饩 ப
 *	*il2 		--  ⥪饩 ப
 *	*n1 		-- 㬬ୠ  ப  ப (string + substring)
 *
 * :
 *
 *	1. ஢  ப  ப  ॢ襭
 *	   ᨬ쭮 .
 *	2. ᫨  ᭮ ப  ᨬ쭮,
 *	   頥 祭: E_BAD_STR.
 *	3. ᫨  ப  ᨬ쭮,
 *	   頥 祭: E_BAD_SUBSTR.
 *	4. ᫨ 砫쭠  ப  ᨬ쭮,
 *	   頥 祭: E_BAD_NUM.
 *	5. ᫨ ।  ,   㬬
 *	   ப  ப  頥 祭: E_OK.
 *
 *  :
 *
 *	㭪: isvalid_str  ⮣ .
 *
********************************************************************/

int isvalid_strs( UCHAR *str, UCHAR *substr, int num, int n, int *il1, int *il2, int *n1 )
{
  if( isvalid_str( str, n, il1 ) != E_OK) return E_BAD_STR;
  if( isvalid_str( substr, n, il2 ) != E_OK) return E_BAD_SUBSTR;
  if( num > n ) return E_BAD_NUM;
  *n1 = *il1 + *il2;
  return E_OK;
}

/******************26/10/06 13:28************************************
 *
 *  istrFind_FWD
 *
 *	 㭪 ⢫  ப  ப "।",
 *	᫥ ࠢ.
 *
 * :
 *	*str 		-- ப,  ன  ப.
 *	*substr 	-- ப,    ப.
 *	num 		-- 砫쭠   ப,
 *			    ன 稭 .
 *	n 		-- ᨬ쭠  ப.
 *	*il2 		--  ப.
 *
 * :
 *
 *	1. ஢ ࠭祭   ப  ப.
 *	2. ஢ ⥫쭮 㬬୮  ப.
 *	3.  ந室  横 ᪠ ப  ப,
 *	     㪠⥫ ᯮ .
 *	4. ᫨ ப , 頥    ப.
 *	5.  頥 祭 E_NO_OCCURENCE
 *	   (⥫쭮 ᫮).
 *
 *  :
 *	㭪: isvalid_strs  ⮣ .
 *
********************************************************************/

int istrFind_FWD( UCHAR *str, UCHAR * substr, int num, int n, int *il2 )
{
  int il1, i, j, k, n1, ierr;
  if( (ierr=isvalid_strs( str, substr, num, n, &il1, il2, &n1 )) != E_OK) return ierr;
  if( n1 < 0 ) return E_BAD_SUBSTR;
  for ( i=num; i <= il1; i++ )
  {
    for( j=0, k=i; j < *il2, k < il1; j++, k++)
    {
	if( str[k] != substr[j] ) break;
    }
    if( j == *il2 ) return i;
  }
  return E_NO_OCCURENCE;
}


/**********************26/10/09 13:35*********************************
 *
 *  istrFind_BWD:
 *
 *	 㭪 ⢫  ப  ப "",
 *	ࠢ .
 *
 * :
 *	*str 	-- ப,  ன  ப.
 *	*substr -ப,    ப.
 *	num 	-- 砫쭠   ப,  ன 稭 .
 *	n 	-- ᨬ쭠  ப.
 *	*il2 	--  ப.
 *
 * :
 *
 *	1. ஢ ࠭祭   ப  ப.
 *	2. ஢ ⥫쭮 㬬୮  ப.
 *	3.  ந室  横 ᪠ ப  ப,
 *	     㪠⥫ ᯮ .
 *	4. ᫨ ப , 頥    ப.
 *	5.  頥 祭 E_NO_OCCURENCE
 * 	   (⥫쭮 ᫮).
 *
 *  :
 *
 *	㭪: isvalid_strs  ⮣ .
 *
*********************************************************************/

int istrFind_BWD( UCHAR *str, UCHAR *substr, int num, int n, int *il2 )
{
  int il1, i, j, k, n1, ierr;
  if( (ierr=isvalid_strs( str, substr, num, n, &il1, il2, &n1 )) != E_OK) return ierr;
  n1 = num - *il2;
  if( n1 < 0 ) return E_BAD_SUBSTR;
  for ( i=n1; i>=0; i-- )
  {
    for( j=0, k=i; j < *il2, k < il1; j++, k++)
    {
	if( str[k] != substr[j] ) break;
    }
    if( j == *il2 ) return i;
  }
  return E_NO_OCCURENCE;
}

/***********************************************************************
 *
 *  istrDel
 *
 *	 㭪 㤠  ⥪饩 ப ⥪, 稭  樨
 *	ipos  ⢥ il0 ᨬ  뢠 १  ப
 *	*newstr.
 *
 *` :
 *	*str 	-- 室 ப;
 * 	ipos 	-- 砫쭠  㤠 ᨬ;
 *	il0 	-- ⢮ 㤠塞 ᨬ;
 *	n 	-- ᨬ쭠  ப ᨬ (  ॢ).
 *	*newstr -ப,   뢠 १ ⠭.
 *
 *  :
 *
 *	E_OK 		-- 㤠 諮 ᯥ譮.
 *	E_BAD_STR	-- 訡   ப (ॢ襭 ᨬ쭠 ).
 *	E_BAD_NUM	-- 訡  砫쭮  筮 樨 㤠塞 ⥪.
 *
 *
 *  :
 *
 *	㭪: isvalid_str  ⮣ .
 *	⠭ 㭪樨 ⥪    STRING.H
 *
*************************************************************************/

int istrDel( UCHAR *str, int ipos, int il0, int n, UCHAR *newstr )
{
  int il1;
  if( isvalid_str( str, n, &il1 ) != E_OK) return E_BAD_STR;
  if( ipos > n || il0 > n ) return E_BAD_NUM;
  strncpy( (char *)newstr, (const char *)str, (size_t)ipos );
  strncat( (char *)newstr, (const char *)&str[ipos+il0], (size_t)n );
  return E_OK;
}


/***********************************************************************
 *
 *  istrIns
 *
 *	 㭪 ⠢  ⥪ ப *str ⥪  ப
 *	*substr, 稭  樨 num  뢠 १  ப
 *	*newstr.
 *
 *` :
 *	*str 	-- 室 ப;
 *	*substr -⠢塞 ப;
 * 	num 	-- 砫쭠  㤠 ᨬ;
 *	n 	-- ᨬ쭠  ப ᨬ (  ॢ).
 *	*newstr -ப,   뢠 १ ⠭.
 *
 *  :
 *
 *	  訡 㭪樨 isvalid_strs();
 *
 *	E_OK 		-- 㤠 諮 ᯥ譮.
 *	E_BAD_SUBSTR - 訡   ப
 *			   (ॢ襭 ᨬ쭠  १饩 ப).
 *
 *  :
 *
 *	㭪: isvalid_strs  ⮣ .
 *	⠭ 㭪樨 ⥪    STRING.H
 *
 *
 *
*************************************************************************/

int istrIns( UCHAR *str, UCHAR *substr, int num, int n, UCHAR *newstr )
{
  int il1, il2, n1, ierr;
  if( (ierr=isvalid_strs( str, substr, num, n, &il1, &il2, &n1 )) != E_OK) return ierr;
  if( n1 > n ) return E_BAD_SUBSTR;
  strncpy( (char *)newstr, (const char *)str, (size_t)num );
  strncat( (char *)newstr, (const char *)substr, (size_t)il2 );
  strncat( (char *)newstr, (const char *)&str[num], (size_t)n1 );
  return 0;
}

/***********************************************************************
 *
 *  istrRepl
 *
 *	㭪 istrRepl  ⥪  ⥪饩 ப *str,
 *	稭  樨 ipos   १ ꥪ il0,
 *	⥪⮬  ப *substr  뢠 १  ப
 *	*newstr.
 *
 *` :
 *	*str 	-- 室 ப;
 *	ipos	-- 砫쭠   ப, 稭  ன
 *		    ⥪  ப *substr;
 *	il0	-- ⢮ 塞 ᨬ  室 ப
 *		   (   ࠢ  *substr)
 *	*substr -- ⠢塞 ப;
 *	*newstr -- ப,   뢠 १ .
 *
 *  :
 *
 *	  訡 㭪樨 isvalid_strs;
 *	  訡 㭪樨 istrDel;
 *	  訡 㭪樨 istrIns;
 *
 *	E_OK 		-- 㤠 諮 ᯥ譮.
 *	E_BAD_SUBSTR 	-- 訡   ப
 *			   (ॢ襭 ᨬ쭠 
 *			    १饩 ப).
 *	E_BAD_NUM	-- 砫쭠  ப   㤠塞
 *			   ⥪ ॢ蠥 ᨬ쭮 祭.
 *	E_BAD_MEMORY_HEAP -ந諠 訡 뤥 ६
 *			   ⨢   ஬ ப.
 *
 *  :
 *
 *	㭪: isvalid_strs  ⮣ .
 *	㭪: istrDel  ⮣ .
 *	㭪: istrIns  ⮣ .
 * 	⠭ 㭪樨 ⥪    ALLOC.H
 *
*************************************************************************/

int istrRepl( UCHAR *str, int ipos, int il0, UCHAR *substr, int n, UCHAR *newstr )
{
  int il1, il2, n1, ierr;
  UCHAR *temp = NULL;
  if( ipos > n || il0 > n ) return E_BAD_NUM;
  if( (ierr=isvalid_strs( str, substr, ipos, n, &il1, &il2, &n1 )) != E_OK) return ierr;
  if( il1-(il0-ipos)+il2 > n ) return E_BAD_SUBSTR;
  if( (temp = (UCHAR *) calloc( n, sizeof(UCHAR)) ) == NULL)
    return E_BAD_MEMORY_HEAP;
  ierr=istrDel( str, ipos, il0, n, temp );
  if( ierr != E_OK ) return ierr;
  ierr=istrIns( temp, substr, ipos, n, newstr );
  free ( temp );
  if( ierr != E_OK ) return ierr;
  return E_OK;
}

/***********************************************************************
 *
 *  istrDelete
 *
 *	 㭪 㤠  ⥪饩 ப ⥪, 稭  樨
 *      ipos  ⢥ il0 ᨬ  뢠 १  ne  ப
 *
 *` :
 *	*str 	-- 室 ப;
 * 	ipos 	-- 砫쭠  㤠 ᨬ;
 *	il0 	-- ⢮ 㤠塞 ᨬ;
 *	n 	-- ᨬ쭠  ப ᨬ (  ॢ).
 *	*newstr -ப,   뢠 १ ⠭.
 *
 *  :
 *
 *	E_OK 		-- 㤠 諮 ᯥ譮.
 *	E_BAD_STR	-- 訡   ப (ॢ襭 ᨬ쭠 ).
 *	E_BAD_NUM	-- 訡  砫쭮  筮 樨 㤠塞 ⥪.
 *      E_BAD_MEMORY_HEAP - 訡 뤥   ६ ᨢ  ""
 *
 *
 *  :
 *
 *      㭪: istrDel  ⮣ .
 *	⠭ 㭪樨 ⥪    STRING.H
 *      ⠭ 㭪樨 ⥪    ALLOC.H
 *
*************************************************************************/

int istrDelete( UCHAR *str, int ipos, int il0, int n )
{
  int ierr = E_OK;
  UCHAR *temp = NULL;
  if( (temp = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  ierr=istrDel( str, ipos, il0, n, temp );
  if( ierr != E_OK ) return ierr;
  strncpy( (char *)&str[0], (const char *)&temp[0], (size_t)n);
  free( temp );
  return E_OK;
}

/***********************************************************************
 *
 *  istrInsert
 *
 *	 㭪 ⠢  ⥪ ப *str ⥪  ப
 *      *substr, 稭  樨 num  ९뢠 १  ப
 *      *str.
 *
 *` :
 *	*str 	-- 室 ப;
 *	*substr -⠢塞 ப;
 * 	num 	-- 砫쭠  㤠 ᨬ;
 *	n 	-- ᨬ쭠  ப ᨬ (  ॢ).
 *
 *  :
 *
 *        訡 㭪樨 istrIns;
 *
 *      E_BAD_MEMORY_HEAP - 訡 뤥   ६ ᨢ  ""
 *
 *  :
 *
 *      㭪: istrIns  ⮣ .
 *	⠭ 㭪樨 ⥪    STRING.H
 *      ⠭ 㭪樨 ⥪    ALLOC.H
 *
 *
*************************************************************************/

int istrInsert( UCHAR *str, UCHAR *substr, int num, int n )
{
  int ierr = E_OK;
  UCHAR *temp = NULL;
  if( (temp = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  ierr=istrIns( str, substr, num, n, temp );
  if( ierr != E_OK ) return ierr;
  strncpy( (char *)str, (const char *)temp, (size_t)n);
  free( temp );
  return E_OK;
}

/***********************************************************************
 *
 *  istrReplace
 *
 *	㭪 istrRepl  ⥪  ⥪饩 ப *str,
 *	稭  樨 ipos   १ ꥪ il0,
 *      ⥪⮬  ப *substr
 *       뢠 ⭮.
 *
 *` :
 *	*str 	-- 室 ப;
 *	ipos	-- 砫쭠   ப, 稭  ன
 *		    ⥪  ப *substr;
 *	il0	-- ⢮ 塞 ᨬ  室 ப
 *		   (   ࠢ  *substr)
 *	*substr -- ⠢塞 ப;
 *
 *  :
 *
 *        訡 㭪樨 istrRepl;
 *
 *	E_OK 		-- 㤠 諮 ᯥ譮.
 *	E_BAD_SUBSTR 	-- 訡   ப
 *			   (ॢ襭 ᨬ쭠 
 *			    १饩 ப).
 *	E_BAD_NUM	-- 砫쭠  ப   㤠塞
 *			   ⥪ ॢ蠥 ᨬ쭮 祭.
 *	E_BAD_MEMORY_HEAP -ந諠 訡 뤥 ६
 *			   ⨢   ஬ ப.
 *
 *  :
 *
 *      㭪: istrRepl  ⮣ .
 *	⠭ 㭪樨 ⥪    STRING.H
 * 	⠭ 㭪樨 ⥪    ALLOC.H
 *
*************************************************************************/

int istrReplace( UCHAR *str, int ipos, int il0, UCHAR *substr, int n )
{
  int il1, il2, n1, ierr = E_OK;
  UCHAR *temp = NULL;
  if( (temp = (UCHAR *) calloc (n, sizeof( UCHAR ))) == NULL )
    return E_BAD_MEMORY_HEAP;
  ierr = istrRepl( str, ipos, il0, substr, n, temp );
  if( ierr != E_OK ) return ierr;
  strncpy( (char *)&str[0], (const char *)&temp[0], (size_t)n);
  free( temp );
  return E_OK;
}
